from utils import *
from time import ctime

import sqlManager
import globals
from sqlalchemy import *

def getStreamRepackGridData(runid):
    streamerTable = Table('streamer', globals.meta, autoload = True)
    assocTable = Table('repack_streamer_assoc', globals.meta, autoload = True)

    cols = (
            ["Stream", None],
            ["Repacked", None],
        )

    query = select(
                (assocTable.c.streamer_id, assocTable.c.repacked_id),
                streamerTable.c.run_id == runid,
                from_obj = [streamerTable.outerjoin(assocTable)]
                )

    sqlResult = sqlManager.executeQuery(query)
    data = []
    data1 = {}
    data2 = {}
    for line in sqlResult:
        if not data1.has_key(line[0]) == None: data1[line[0]] = []
        data1[line[0]].append(line[1])
        if not data2.has_key(line[1]): data2[line[1]] = []
        data2[line[1]].append(line[0])
    data.append(data1)
    data.append(data2)
    sqlResult.close()

    gd = GridData("Run " + str(runid) + " streamer repack state", data, cols)
    return gd

class GridData:
    def __init__(self, title, data, cols):
        self.title = title
        self.data = data
        self.cols = cols
