import globals
import config
from utils import *

def getGridGui(gd):
    grid = '<table border="0" style="font-size:8px;">\n'
    grid += '<tr>'
    grid += '<th colspan="' + str(len(gd.data[0].keys()) + 1) + '">' + gd.title + "</th>"
    grid += '</tr>\n'
    grid += '<tr>'
    grid += '<th>' + gd.cols[0][0] + '<br/> ' + gd.cols[1][0] + '</th>'
    keys = gd.data[0].keys()
    for key in keys:
        grid += '<th>'
        skey = str(key)
        for i in range(0, len(skey)):
            grid += skey[i] + '<br />'
        grid += '</th>'
    grid += '</tr>'
    for key in gd.data[1].keys():
        grid += '<tr>'
        grid += '<th>' + str(key) + '</th>'
        for key2 in gd.data[0].keys():
            if gd.data[1][key].count(key2) != 0:
                grid += '<td style="background-color:green"></td>'
            else:
                grid += '<td></td>'
        grid += '</tr>'
    grid += '</table>'
    return grid

def getTableGui(id, td, pageMenuLen = 50):
    table = ""
    table += '<table border="0" cellspacing="2">\n'

    # Title

    table += '<tr>'
    table += '<th colspan="' + str(len(td.cols)) + '">' + td.title + \
        " [query=" + str(int(td.qtime)) + "ms"
#    if hasattr(td, "dataCount"):
#        table += ", numrows = " + str(td.dataCount);
    table += "]</th>"
    table += '</tr>\n'

    # Paging

    if hasattr(td, "dataCount"):
        all = "All "
        if td.dataCount > td.pageSize:
            table += '<tr>\n'
            table += '<td colspan="' + str(len(td.cols)) + '">'
            if td.page != None:
                table += '<a href="' + formGetParameters({id + "_p" : "all"}) + '">'
            table += all
            if td.page != None:
                table += '</a>'
            r = td.dataCount / td.pageSize
            if td.dataCount % td.pageSize != 0:
                r += 1
            numchars = len(all)
            for i in range(r):
                if i != td.page:
                    table += '<a href="' + formGetParameters({id + "_p" : i}) + '">'
                caption = str(i + 1) + " "
                table += caption
                numchars += len(caption)
                if i != td.page:
                    table += "</a>"
                if numchars >= pageMenuLen:
                    table += "<br />"
                    numchars = 0
            table += '</td>\n'
            table += '</tr>\n'

    # Orderby

    table += "<tr>"
    for i in range(0, len(td.cols)):
        table += '<td style="background-color:#b9d0de">'
        if td.orderby == i:
            if td.asc == True:
                table += '<img src="/T0Mon/images/orderasc.png" alt="" />'
            else:
                table += '<img src="/T0Mon/images/orderdesc.png" alt="" />'
        table += '<a href="'
        value = str(i) + "_"
        if td.orderby == i :
            value += str(not td.asc)
        else:
            value += str(False)
        params = {}
        params[id] = value
        table += formGetParameters(params)
        table += '">' \
            + td.cols[i][0] \
            + "</a>"
        table += "</td>"
    table += "</tr>\n"

    # Body

    start = 0 * config.PAGE_SIZE;
#    for j in range (start, start + consts.PAGE_SIZE):
    for j in range(len(td.data)):
        if (j >= len(td.data)): break;
        table += "<tr>"
        for i in range(0, len(td.cols)):
            cell = td.data[j][i]
            if td.cols[i][1] != None:
                cell = td.cols[i][1](cell)
            table += "<td "
            if (j % 2 == 0):
                table += 'style="background-color:white"'
            table += ">" + str(cell) + "</td>"
        table += "</tr>\n"
        j += 1

    table += "</table>"
    return table

def getVertTableGui(id, td):
    table = ""
    table += '<table border="0">\n'
    table += '<tr>'
    table += '<th colspan="' + str(len(td.data) + 1) + '">' + str(td.title) + " " + "[" + str(int(td.qtime)) + "ms]" + "</th>"
    table += '</tr>\n'

    for i in range(len(td.cols)):
        table += "<tr>"
        table += "<td "
        if (i % 2 == 0):
            table += 'style="background-color:white"'
        table += ">" + td.cols[i][0] + "</td>"
        for j in range(len(td.data)):
            if (i < len(td.data[j])):
                table += "<td "
                if (i % 2 == 0):
                    table += 'style="background-color:white"'
                cell = td.data[j][i]
                if td.cols[i][1] != None:
                    cell = td.cols[i][1](cell)
                table += ">" + str(cell) + "</td>"
        table += "</tr>"

    table += "</table>"
    return table
