from sqlalchemy import *

from config import *

import globals
import time
import datetime

connection = None

def initBasicConnection():
    """
    Connect to DB

    Connect to DB using sqlalchemy using cx_oracle
    """
    global connection
    if (connection == None):
        # tier0DB = Operation.Operation(loadConfig('Tier0DB'))
        # return tier0DB.connection
        engine = create_engine('oracle://' + DB_USER + ":" + DB_PASSWORD + "@" + DB_TNS)

        globals.meta = MetaData()
        globals.meta.bind = engine

        connection = engine.connect()

def sqlResultToData(sqlResult):
    data = []
    for line in sqlResult: data.append(line)
    sqlResult.close()
    return data

def executeQuery(query, bindParams = None):
    if (connection == None):
        initBasicConnection()
    start = datetime.datetime.now()
    try:
        if (bindParams != None):
            queryResult = connection.execute(query, bindParams)
        else:
            queryResult = connection.execute(query)
    except StandardError, ex:
        # connection.close()
        raise RuntimeError, "Failed to query : %s\n" % str(ex)
    delta = datetime.datetime.now() - start
    queryResult.time = delta.seconds * 1000 + delta.microseconds / float(1000)
    # connection.close()
    # globals.logger.log(query)
    return queryResult
